; exemple1.nsi
;
; ce premier exemple install Openssl.exe et ses DLL dans program files
; le repertoire d'openssl ne contient pas la version car il ne semble pas 
; ncessaire de faire cohexister plusieurs versions OpenSSL sur un
; mme systme.
;--------------------------------

; fonctions permettant de modifier les variables d'environnement
!include AddToPath.nsh

;--------------------------------

; le nom du programme d'installation
Name "OpenSSL 0.9.8d";
 

; le nom du fichier d'installation
OutFile "OpenSSL.0.9.8d.exe"

; le rpertoire d'installation par dfaut
InstallDir $PROGRAMFILES\OpenSSL

LoadLanguageFile "${NSISDIR}\Contrib\Language files\French.nlf"

InstallDirRegKey HKLM "Software\OpenSSL" "Install_Dir"

;--------------------------------

; Pages

Page directory
Page instfiles


UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

Section "Out32dll" 

  
  SetOutPath $INSTDIR
  
  ; les fichiers
  File ..\out32dll\openssl.exe
  File ..\out32dll\libeay32.dll
  File ..\out32dll\ssleay32.dll
 
  ; mise  jour du path
  Push $INSTDIR
  Call AddToPath

  ; mmorisation des lments ncessaires  la dsinstallation
  WriteRegStr HKLM SOFTWARE\OpenSSL "Install_Dir" "$INSTDIR"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\OpenSSL" "DisplayName" "OpenSSL 0.9.8d"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\OpenSSL" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\OpenSSL" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\OpenSSL" "NoRepair" 1
  WriteUninstaller "uninstall.exe"

  
SectionEnd ; fin Out32dll

Section "un.Out32dll"

  ; mise  jour du path
  Push $INSTDIR
  Call un.RemoveFromPath

  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\OpenSSL"
  DeleteRegKey HKLM SOFTWARE\OpenSSL

  ; Remove files and uninstaller
  Delete $INSTDIR\openssl.exe
  Delete $INSTDIR\libeay32.dll
  Delete $INSTDIR\ssleay32.dll
  
  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\OpenSSL\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\OpenSSL"
  RMDir "$INSTDIR"
  

SectionEnd ; fin un.Out32dll